<?php
//SE VERSION 0.1	
/*Start Config area*/

$lang = "IT"; //lingua utilizzata nell'head del template
$title = "SE-SITE Simple Easy Content Visual System"; //Titolo del sito o della sezione del sito usato nell'head, se non viene sovrascritto dal singolo file
$description = "ovvero un modo semplice di gestire un semplice sito"; //Descrizione del sito usato nell'head, se non viene sovrascritto dal singolo file
$keyword = "CMS semplice, CMS PHP, CMS leggero, CMS facile, Flat file CMS, CMS senza database"; //Keyword del sito usato nell'head, se non viene sovrascritto dal singolo file
$author = "Fabio Zappa"; //Autore del sito usato nell'head, se non viene sovrascritto dal singolo file

$logo_img = "asset/logo.png";//La posizione del file del logo mostrato in alto a sinistra
$logo_txt = "MCVS"; //Il titolo che esce sul logo

$template = "layout1"; //Il templete utilizzato, verranno cercati il file html con questo nome e la directory con questo nome nella cartella asset
$directory_data = "data/";//La directory che contiene i file

$order_data = "inc";//Serve per decidere come ordinare i file, inc(increasing/crescente: 00-01-..-99);dec(decreasing/decrescente: 99-98-..01)
/*End Config area*/	

//Stabilisco il protocollo per creare i link
$procol = "http";//definisco il protocollo http come predefinito
if ( isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on' ) $procol = "https";//se sono in modalità https cambio il protocollo

//Creo e definisco i link del sito
$dir_base = $procol."://".$_SERVER["HTTP_HOST"];
$link_base = $dir_base.$_SERVER["PHP_SELF"];

//Creo le variabili che contengono il nome del file del template e della directory
$template_file = "asset/".$template.".html";
$template_dir = "asset/".$template."/";

$site_title = " ".$title; //Salvo il titolo originale del file, nella pagina lo accoderò al titolo della pagina

//Questi elementi sono gli elementi html che saranno usati per comporre il layout del sito, possono essere definiti qui o nel file.html, è preferibile definirli nel file.html perchè in caso di convivenza di due o più layout potrebbe generare dei problemi.
$menu_start = ''; //Definita nel template
$menu_class_active = ''; //Definita nel template
$menu_class_inactive = ''; //Definita nel template
$menu_class_show = ''; //Definita nel template
$menu_class_hide = ''; //Definita nel template
$menu_element_link = ''; //Definita nel template
$menu_element_submenu = ''; //Definita nel template
$menu_element_submenu_link = ''; //Definita nel template
$menu_element_stop = ''; //Definita nel template
$menu_stop = ''; //Definita nel template



//Azzero la visualizzazione degli errori di PHP
ini_set('display_errors', '0');
error_reporting(0);

//Con questo ciclo analizzo il file template e salvo il codice html nella variabili tpl, analizzando il codice valorizzo tutte le variabili $menu_* definite nel template (consultare il sito per i dettagli)
//Se il file non esiste genero un errore
if ($ftpl = fopen($template_file, 'r')) {
	$tpl = "";
    while (!feof($ftpl)) {
	    $c_line = fgets($ftpl);
	    if(substr($c_line, 0,8) == '<!--MENU'){
			$a_content = explode("-->", substr($c_line, 8));
			$nome_variabile = "menu_".strtolower(trim($a_content[0]));
			$$nome_variabile = trim($a_content[1]);
		    
	    }else{
	        $tpl .= $c_line;		    
	    }	    
    }
    fclose($ftpl);

}else{
	print("Error: Template ".$template_file." file not found!");
	exit();
}

//Creazione del logo
if(file_exists($logo_img)){
	$logo = "<img src='".$logo_img."' alt='".$logo_txt."' title='".$title."'>";
}else{
	$logo = $logo_txt;
}

//Creazione del menu - Questa funzione scandaglia tutta la directory che contiene i dati e crea il menu di sinistra, le parti html che compongono il menu sono inserite nelle variabili $menu_* valorizzate sopra con i contenuti del template
function create_menu($directory, &$prog_id, $class_show_hide) {
	$order = $GLOBALS['order_data'];
	//Nella directory mettere un file php facoltativo che riscrive questo valore

	$li_menu = array();
	$ul_menu = array();
	if ($data_dir = opendir("./" . $directory)){
		while ($file = readdir($data_dir)){
			if ($file != "." & $file != ".."){
				if (is_dir("./".$directory."/".$file) || substr($file, -4) == '.txt'){
					$li_menu[] = $file;
					if (is_dir("./".$directory."/".$file)){
						$ul_menu[] = $file;
					}
				}
			}
		}
	}
	closedir($data_dir);
	reset($li_menu);
	if($order == "dec") rsort($li_menu);
	else sort($li_menu);
	reset($li_menu);
	$prog_id_ul = $prog_id;
	$menu_li = "";
	//$elementi_directory = array();
	$line_number = 0;
	while(list($kli, $vli) = each($li_menu)){
		$line_number++;
		$prog_id++;

		if(in_array($vli, $ul_menu)){
			$next_ul_id = $prog_id+1;
			$class_show_hide_p = $GLOBALS['menu_class_hide'];
			$class = $GLOBALS['menu_class_inactive'];
			$menu_page_name = substr($vli,strpos($vli, "_")+1);
			if(file_exists($directory.$vli.".txt")){
				$link_li = $GLOBALS['link_base']."?cid=".$prog_id;
				$elink_li = $GLOBALS['link_base']."?eid=".$vli.".txt";

				$GLOBALS['array_page_id'][] = $prog_id;
				$GLOBALS['array_page_name'][] = $menu_page_name;

				if(empty($_GET['cid']) && empty($_GET['eid']) && $GLOBALS['content_dir'] == "" && $GLOBALS['content_file'] == ""){
					$GLOBALS['content_dir'] = $directory;
					$GLOBALS['content_file'] = $vli.".txt";
					$class = $GLOBALS['menu_class_active'];
					$class_show_hide_p = $GLOBALS['menu_class_show'];
					$GLOBALS['page_link'] = $GLOBALS['link_base'];
					$GLOBALS['page_e_link'] = $GLOBALS['link_base'];
					$GLOBALS['actual_page'] = $prog_id;
				}
				if((!empty($_GET['cid']) && $_GET['cid'] == $prog_id) || (!empty($_GET['eid']) && $_GET['eid'] == $vli.".txt") ){
					$GLOBALS['content_dir'] = $directory;
					$GLOBALS['content_file'] = $vli.".txt";
					$class = $GLOBALS['menu_class_active'];
					$class_show_hide_p = $GLOBALS['menu_class_show'];
					$GLOBALS['page_link'] = $link_li;
					$GLOBALS['page_e_link'] = $elink_li;
					$GLOBALS['actual_page'] = $prog_id;
					
				}

				$a_replace = array();
				$a_replace['--PROGID--'] = $prog_id;
				$a_replace['--CLASS_ACTIVE_INACTIVE--'] = $class;
				$a_replace['--NEXTID--'] = $next_ul_id;
				$a_replace['--LINK_ELEMENT--'] = $link_li;
				$a_replace['--MENU_PAGE_NAME--'] = $menu_page_name;
				$menu_li .= str_replace(array_keys($a_replace), $a_replace, $GLOBALS['menu_element_submenu_link']);

			}else{

				$a_replace = array();
				$a_replace['--PROGID--'] = $prog_id;
				$a_replace['--CLASS_ACTIVE_INACTIVE--'] = $class;
				$a_replace['--NEXTID--'] = $next_ul_id;
				$a_replace['--MENU_PAGE_NAME--'] = $menu_page_name;
				$menu_li .= str_replace(array_keys($a_replace), $a_replace, $GLOBALS['menu_element_submenu']);

			}
			$sub_directory = $directory.$vli."/";
			$prog_id++;
			$menu_li .= create_menu($sub_directory, $prog_id, $class_show_hide_p);
			$menu_li .= $GLOBALS['element_stop'];
		}else{
			$link_li = $GLOBALS['link_base']."?cid=".$prog_id;
			$elink_li = $GLOBALS['link_base']."?eid=".$vli;
			$menu_page_name = str_replace(".txt","",substr($vli,strpos($vli, "_")+1));

			$class = $GLOBALS['menu_class_inactive'];
						
			if(empty($_GET['cid']) && empty($_GET['eid']) && $GLOBALS['content_dir'] == "" && $GLOBALS['content_file'] == ""){
				$class = $GLOBALS['menu_class_active'];
				$GLOBALS['content_dir'] = $directory;
				$GLOBALS['content_file'] = $vli;
				$GLOBALS['page_link'] = $GLOBALS['link_base'];
				$GLOBALS['page_e_link'] = $GLOBALS['link_base'];
				$GLOBALS['actual_page'] = $prog_id;
			}
			if((!empty($_GET['cid']) && $_GET['cid'] == $prog_id) || (!empty($_GET['eid']) && $_GET['eid'] == $vli) ){
				$class = $GLOBALS['menu_class_active'];
				$GLOBALS['content_dir'] = $directory;
				$GLOBALS['content_file'] = $vli;
				$GLOBALS['page_link'] = $link_li;
				$GLOBALS['page_e_link'] = $elink_li;
				$GLOBALS['actual_page'] = $prog_id;

			}

			if(!in_array(str_replace(".txt","",$vli), $ul_menu)){
				$a_replace = array();
				$a_replace['--PROGID--'] = $prog_id;
				$a_replace['--CLASS_ACTIVE_INACTIVE--'] = $class;
				$a_replace['--LINK_ELEMENT--'] = $link_li;
				$a_replace['--MENU_PAGE_NAME--'] = $menu_page_name;
				$menu_li .= str_replace(array_keys($a_replace), $a_replace, $GLOBALS['menu_element_link']);
				$GLOBALS['array_page_id'][] = $prog_id;
				$GLOBALS['array_page_name'][] = $menu_page_name;
			}else{
				$line_number--;
			}
			$menu_li .= $GLOBALS['element_stop'];
		}

	}
	$ul_class = $GLOBALS['menu_class_hide'];
	if($prog_id_ul == 0 || stripos( $GLOBALS['content_dir'], $directory) === 0 || $class_show_hide == $GLOBALS['menu_class_show']) $ul_class = $GLOBALS['menu_class_show'];
	$a_replace = array();
	$a_replace['--PROGID--'] = $prog_id_ul;
	$a_replace['--CLASS_SHOW_HIDE--'] = $ul_class;
	$menu_sx = str_replace(array_keys($a_replace), $a_replace, $GLOBALS['menu_start']);
	$menu_sx .= $menu_li;
	$menu_sx .=  $GLOBALS['menu_stop'];
	return($menu_sx);
}//End function create_menu


//Conversione del contenuto in html - Per i dettagli della sintassi consultare il sito
function content_to_html($content) {

	$escape_code["\\*"] = "^|1e|^";
	$escape_code["\\-"] = "^|2e|^";
	$escape_code["\\+"] = "^|3e|^";
	$escape_code["\\1"] = "^|6e|^";
	$escape_code["\\#"] = "^|7e|^";
	$escape_code["\\|"] = "^|8e|^";

	$escape_code["\\["] = "^|9e|^";
	$escape_code["\\]"] = "^|10e|^";
	$escape_code["\\("] = "^|11e|^";
	$escape_code["\\)"] = "^|12e|^";
	$escape_code['\\"'] = "^|13e|^";
	$escape_code["\\'"] = "^|14e|^";


	$escape_code_noret["\\<"] = "&lt;";
	$escape_code_noret["\\>"] = "&gt;";


	$content = str_replace(array_keys($escape_code), $escape_code, $content);

	$content = str_replace(array_keys($escape_code_noret), $escape_code_noret, $content);
	
	//Uniformo i line break
	$content = str_replace(array("\r\n", "\r"), "\n", $content);
	//Pulisco gli spazi vuoti a inizio e fine
	$content = trim($content, "\n");
	//Creo un array con i conenuti
	$linee = explode("\n", $content);
	//Analizzo ogni riga e genero il contenuto finale
	$html = "";
	$start_ul = "";
	$start_ol = "";
	$start_bq = "";
	$start_table = "";
	$line_table = 0;
	$row_table = 0;
	foreach($linee AS $k => $v ){
		$ins_br = "y";
		$v_nospace = str_replace(" ", "", $v);
		$v1char = substr($v_nospace, 0, 1);
		$v2char = substr($v_nospace, 0, 2);
		$v3char = substr($v_nospace, 0, 3);
		
		if($v1char != '+' && $v1char != '-' && $start_ul == "<ul>"){
			$html .= "</ul>";
			$start_ul = "";
		}

		if($v2char != '1.' && $start_ol == "<ol>"){
			$html .= "</ol>";
			$start_ol = "";
		}		

		if($v1char != '>' && $start_bq == "<blockquote>"){
			$html .= "</blockquote>";
			$start_bq = "";
		}

		if($v1char != '|' && $start_table == "<table>"){
			$html .= "</table>";
			$start_table = "";
			$line_table = 0;
			$row_table = 0;
		}


		if($v3char == '---' ){
			$ins_br = "n";
			$html .= "<hr />";
		}elseif($v1char == '+' || $v1char == '-'){
			$ins_br = "n";
			if($start_ul == ""){
				$html .= "<ul>";
				$start_ul = "<ul>";
			}
			$html .= "<li>".substr($v,1)."</li>";
		}elseif($v1char == '>'){
			$ins_br = "n";
			if($start_bq == ""){
				$html .= "<blockquote>";
				$start_bq = "<blockquote>";
			}
			$html .= substr($v,1)."<br>";
		}elseif($v1char == '|'){
			$ins_br = "n";
			if($start_table == ""){
				$html .= "<table>";
				$start_table = "<table>";
			}
			$line_table++;
			if($line_table == 1){
				$row_table = 0;
				$html .= "<tr><th>".str_replace("|","</th><th>",substr($v,1))."</th></tr>";
			}else{
				$html .= "<tr><td>".str_replace("|","</td><td>",substr($v,1))."</td></tr>";				
			}
		}elseif($v2char == '1.'){
			$ins_br = "n";
			if($start_ol == ""){
				$html .= "<ol>";
				$start_ol = "<ol>";
			}
			$html .= "<li>".substr($v,2)."</li>";
		}elseif($v1char == '#'){
			$ins_br = "n";
			if($v_nospace{5} == '#' ) $htype = "h6";
			elseif($v_nospace{4} == '#' ) $htype = "h5";
			elseif($v_nospace{3} == '#' ) $htype = "h4";
			elseif($v_nospace{2} == '#' ) $htype = "h3";
			elseif($v_nospace{1} == '#' ) $htype = "h2";
			else $htype = "h1";
			
			$html .= "<".$htype.">".trim($v,"#")."</".$htype.">";
	
		}else{			
			$html .= "<p>".$v."</p>";
		}
		
		
		if($ins_br == "y") $html .= "";//fine riga metto un a capo
	}

	//Inizio link e immagini
	preg_match_all("~(!)*\[([^\]]+)\]\(([^\)]+?)(?: \"([\w\s]+)\")*\)~", $html, $img_link, PREG_SET_ORDER);

	foreach($img_link as $vars){
		$title = '';
		if(isset($vars[4])) $title = ' title="'.$vars[4].'"' ;
		
		$textlink_alt = $vars[2];
		$link = $vars[3];

		$link_img = $vars[3];
		if(substr($link_img, 0,4) != 'http') $link_img = $GLOBALS['content_dir']."".$vars[3];

		if($vars[1]){
			//Questa è un immagine
			$html = str_replace($vars[0], '<img src="'.$link_img.'" alt="'.$textlink_alt.'" '.$title.'/>', $html);
		}else{
			//Questa è un link
			$html = str_replace($vars[0], '<a href="'.$link.'" '.$title.'>'.$textlink_alt.'</a>', $html);
		}
	}
	//Fine link e immagini

	$html = preg_replace("/\*\*\*(.*?)\*\*\*/", "<strong><em>$1</em></strong>", $html);//Bold-italic
	$html = preg_replace("/\*\*(.*?)\*\*/", "<strong>$1</strong>", $html);//Bold
	$html = preg_replace("/\*(.*?)\*/", "<em>$1</em>", $html);//Italic

	$html = str_replace($escape_code, str_replace("\\","",array_keys($escape_code)), $html);

	return($html);
}//End function content_to_html

//Definisco una serie di variabili che utilizzo in seguito
$prog_id = 0;
$content_dir = "";
$content_file = "";
$prev_page_link = "#";//link alla pagina precedente
$next_page_link = "#";//link alla pagina seguente
$prev_page_name = "";//nome della pagina precedente
$next_page_name = "";//nome della pagina seguente

$actual_page = 0;
$array_page_id = array();//Array contenente il codice identificativo di tutte le pagine, è valorizzato nella funzione create_menu
$array_page_name = array();//Array contenente il nome di tutte le pagine, è valorizzato nella funzione create_menu

$page_link = "";
$page_e_link = "";
$menu_sx = create_menu($directory_data, $prog_id, "show");

$number_of_page = count($array_page_id);//numero totale delle pagine
$idex_of_page = array_search($actual_page, $array_page_id);//indice negli array $array_page_id e $array_page_name della pagina che sto guardando

//Genero nome e link della pagina precedente
if($actual_page > 1){//se non è la prima pagina
	$index_prev = $idex_of_page - 1;
	$prev_page_link = $GLOBALS['link_base']."?cid=".$array_page_id[$index_prev];
	$prev_page_name = $array_page_name[$index_prev];
}

//Genero nome e link della pagina seguente
if($actual_page < max($array_page_id)){//se non è l'ultima pagina
	$index_next = $idex_of_page + 1;
	$next_page_link = $GLOBALS['link_base']."?cid=".$array_page_id[$index_next];
	$next_page_name = $array_page_name[$index_next];
}
$pagecontent = $content_dir.$content_file;//percorso completo del file del contenuto che voglio visualizzare

//Eseguo la lettura del file con i contenuti ed estrapolo tutte le variabili contenute
//oltre alle variabili utilizzate dal sistema si possono definire altre variabili prima della variabile #CONTENT che possono essere usate se si modifica il programma PHP
$nome_var = "";
if ($ffil = fopen($pagecontent, 'r')) {
	$data_page = "";
    while (!feof($ffil)) {
        $data_line = fgets($ffil);
        if($data_line{0} == '#' && $nome_var != 'content'){
			$nome_var = strtolower(trim(substr($data_line, 1, strpos($data_line, ":")-1)));
			$$nome_var = trim(substr($data_line, strpos($data_line, ":")+1));
        }else{
	       $$nome_var .= $data_line;
        }
    }
    fclose($ffil);

}else{
	$pagecontent = "Error: Page ".$pagecontent." file not found!";
}
//Se la variabile $location è stata valorizzata dai contenuti della pagina che stò mostrando indirizzo il visitatore verso il nuovo indirizzo
if(isset($location) && trim($location) != ""){
	header("Location:".$location);
	exit();
}

//Qui richiamo la funzione che converte il linguaggio con cui è scritto il file in codice HTML
$pagecontent = content_to_html($content);

//Genereo un array dove assegno alla chiave che corrisponde alla variabile scritta nel template il valore che deve essere mostrato
//Ad esmpio nel template avrò una variabile --PAGECONTENT-- che dev'essere sostituita con il codice HTML elaborato dalla funzione content_to_html
$variabili = array();
$variabili['--LANG--'] = $lang;
$variabili['--TITLE--'] = $title.$site_title;
$variabili['--PAGETITLE--'] = $title;
$variabili['--DESCRIPTION--'] = $description;
$variabili['--KEYWORDS--'] = $keyword;
$variabili['--AUTHORS--'] = $author;
$variabili['--LOGO--'] = $logo;
$variabili['--MENU_SX--'] = $menu_sx;
$variabili['--PAGECONTENT--'] = $pagecontent;
$variabili['--PREV_PAGE_LINK--'] = $prev_page_link;
$variabili['--NEXT_PAGE_LINK--'] = $next_page_link;
$variabili['--PREV_PAGE_NAME--'] = $prev_page_name;
$variabili['--NEXT_PAGE_NAME--'] = $next_page_name;
$variabili['--PAGE_LINK--'] = $page_link;
$variabili['--PAGE_E_LINK--'] = $page_e_link;

//Eseguo le sostituzioni delle variabili nel codice html del template salvato nella variabile$tpl
$cvs = str_replace(array_keys($variabili), $variabili, $tpl);
//Stampo a video il risultato finale
echo $cvs;


?>